package nz.ac.canterbury.debugassist.datasource;
import java.util.*;

import nz.ac.canterbury.debugassist.model.BreakpointEvent;
import nz.ac.canterbury.debugassist.model.ModelGenerator;
import nz.ac.canterbury.debugassist.model.Variable;

import org.eclipse.debug.core.model.IVariable;
public class DataEventStoreTime {
	private static int hitCount = 0;
	private static ArrayList<BreakpointEvent> dataStore = new ArrayList<BreakpointEvent>();
	
	public static void addVariableData(String stackName, String threadName, IVariable[] rootVariable) {
		Variable[] v = ModelGenerator.generate(rootVariable);
		BreakpointEvent bpe = new BreakpointEvent(new Date(), hitCount++, threadName, stackName, v);
		dataStore.add(bpe);
	}
	
	public static ArrayList<BreakpointEvent> getAllBreakpointEvents() {
		return dataStore;
	}
	
	public static void clearEvents() {
		dataStore.clear();
		hitCount = 0;
	}
	
	
}
