package nz.ac.canterbury.debugassist.pseudobreakpoint;
//text.source.IVerticalRulerInfo
import org.eclipse.core.resources.IResource;
import org.eclipse.debug.core.DebugPlugin;
import org.eclipse.debug.core.model.IBreakpoint;
import org.eclipse.debug.core.model.ILineBreakpoint;
import org.eclipse.jdt.internal.ui.javaeditor.CompilationUnitEditor;
import org.eclipse.jdt.internal.ui.javaeditor.JavaEditor;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IMenuCreator;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.text.source.*;
import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.events.HelpListener;
import org.eclipse.swt.widgets.Event;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.texteditor.AbstractRulerActionDelegate;
import org.eclipse.ui.texteditor.ITextEditor;

public class AddRemovePseudoBreakPointHandler  extends AbstractRulerActionDelegate {
	private IEditorPart targetEditor = null;


	@Override
	protected IAction createAction(ITextEditor editor,
			IVerticalRulerInfo rulerInfo) {
	
		return new PesudoBreakpointAction(editor, rulerInfo);
	}


	public class PesudoBreakpointAction implements IAction {
		ITextEditor editor;
		IVerticalRulerInfo rulerInfo;
		
		public PesudoBreakpointAction(ITextEditor e, IVerticalRulerInfo r) {
			editor = e;
			rulerInfo = r;
		}
		
		@Override
		public void addPropertyChangeListener(IPropertyChangeListener listener) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public int getAccelerator() {
			// TODO Auto-generated method stub
			return 0;
		}

		@Override
		public String getActionDefinitionId() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public String getDescription() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public ImageDescriptor getDisabledImageDescriptor() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public HelpListener getHelpListener() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public ImageDescriptor getHoverImageDescriptor() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public String getId() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public ImageDescriptor getImageDescriptor() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public IMenuCreator getMenuCreator() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public int getStyle() {
			// TODO Auto-generated method stub
			return 0;
		}

		@Override
		public String getText() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public String getToolTipText() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public boolean isChecked() {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public boolean isEnabled() {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public boolean isHandled() {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public void removePropertyChangeListener(
				IPropertyChangeListener listener) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void run() {
			//System.out.println(rulerInfo.getLineOfLastMouseButtonActivity());
			
		}

		@Override
		public void runWithEvent(Event event) {
			// TODO Auto-generated method stub
			try {
				ITextEditor textEditor = editor;
				if (textEditor != null) {
				 IResource resource = (IResource) textEditor.getEditorInput().getAdapter(IResource.class);
				 //ITextSelection textSelection = (ITextSelection) selection;
				 
				 int lineNumber = rulerInfo.getLineOfLastMouseButtonActivity();
				 IBreakpoint[] breakpoints = DebugPlugin.getDefault().getBreakpointManager()
				                .getBreakpoints("org.eclipse.jdt.debug");
				 for (int i = 0; i < breakpoints.length; i++) {
				    IBreakpoint breakpoint = breakpoints[i];
				    if (resource.equals(breakpoint.getMarker().getResource())) {
				       if ((((ILineBreakpoint)breakpoint).getLineNumber() == (lineNumber+1)) && (breakpoint instanceof PseudoBreakpointImpl)) {
				       breakpoint.delete();
				          return;
				       }
				    }
				 }
				 
				String resourceName = resource.getName().substring(0, resource.getName().lastIndexOf('.'));
				
				 //PseudoBreakpointImpl lineBreakpoint = new PseudoBreakpointImpl(resource, lineNumber + 1);
				 PseudoBreakpointImpl lineBreakpoint = new PseudoBreakpointImpl(resource, resourceName, lineNumber+1);
				 DebugPlugin.getDefault().getBreakpointManager().addBreakpoint(lineBreakpoint);
				 
				}
			} catch(Exception ex) {
				
			}
			
			
			
		}

		@Override
		public void setAccelerator(int keycode) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setActionDefinitionId(String id) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setChecked(boolean checked) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setDescription(String text) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setDisabledImageDescriptor(ImageDescriptor newImage) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setEnabled(boolean enabled) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setHelpListener(HelpListener listener) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setHoverImageDescriptor(ImageDescriptor newImage) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setId(String id) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setImageDescriptor(ImageDescriptor newImage) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setMenuCreator(IMenuCreator creator) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setText(String text) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void setToolTipText(String text) {
			// TODO Auto-generated method stub
			
		}
		
	}

}
